#ifndef	_STDIO_H_
#ifndef	_SYS_CDEFS_H_
#if 1 
#if defined0 && __cplusplus >= 201103L
#endif
#endif
#if 1 
#define INLINE __inline static
#endif
typedef unsigned char						UINT8;
      
 typedef signed short						INT16;
      
 typedef unsigned int						UINT32;
      
 typedef signed int							INT32;
#if 0 
#endif
#endif 
#endif 
#define ENV_BITS    10
#define ENV_LEN      (1<<ENV_BITS)
#define ENV_STEP    (128.0/ENV_LEN)
#define SIN_BITS    10
#define SIN_LEN      0
#define SIN_MASK    0
#define TL_RES_LEN    (256) 
#define TL_TAB_LEN 0
static signed int tl_tab[];
      
 static unsigned int sin_tab;
      
 static const UINT8 lfo_pm_output;
#define SLOT1 0
#define SLOT2 2
typedef struct
 {}
       FM_SLOT;
      
 typedef struct
 {
      
   FM_SLOT  SLOT;
           
   INT32   *connect2;
          
 }
       FM_CH;
      
 typedef struct
 {
      
   FM_CH   CH[6];
        
 }
       YM2612;
      
 static YM2612 ym2612;
      
 static INT32  m2,c1,c2;
         
 
      
 INLINE signed int op_calc()
 {
      
   UINT32 p = 0 + sin_tab;
      
   return tl_tab;
      
 }
      
 INLINE void chan_calc(FM_CH *CH)
 
      
   {
     int num = 0;
     
     unsigned int eg_out = 0;
     
     *CH->connect2 += op_calc;
     
   }
      
 
      
 
      
 
      
 static void init_tables()
 {
      
   signed int d,i,x;
      
   signed int n;
      
   double o,m;
      
   for (x=0;
       x<TL_RES_LEN;
       x++)
   {
     
     m = (1<<16) / pow(2,(x+1) * (ENV_STEP/4.0) / 8.0);
     
     m = floor(m);
     
     n = m;
      
     n >>= 4;
         
     if (n&1)    
       n = (n>>1)+1;
     
     else
       n = n>>1;
     
     n <<= 2;
         
     tl_tab[ x*2 + 0 ] = n;
     
     tl_tab[ x*2 + 1 ] = -tl_tab[ x*2 + 0 ];
     
     for (i=1;
      i<13;
      i++)
     {
    
       tl_tab[ x*2+0 + i*2*TL_RES_LEN ] =  tl_tab[ x*2+0 ]>>i;
    
       tl_tab[ x*2+1 + i*2*TL_RES_LEN ] = -tl_tab[ x*2+0 + i*2*TL_RES_LEN ];
    
     }
     
   }
      
 }
      
 void MDYM2612Init()
 {
      
   init_tables();
      
 }
      
 
      
 void MDYM2612Update()
 
      
   
     
     {
    
       chan_calc(&ym2612.CH);
    
     }
     
   
      
 
